package com.example.sinfro;

import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class ElementoSQL extends SQLiteOpenHelper implements Listado {
	
	public ElementoSQL(Context context){
		super(context,"listado", null, 1);
	}
	

	@Override
	public void guardarElemento(String tabla, Elemento e) {
		SQLiteDatabase db = getWritableDatabase();
		ContentValues newValues = new ContentValues();
		
		newValues.put("id", e.getId());
		newValues.put("titulo", e.getTitle());
		newValues.put("autor", e.getAuthor());
		newValues.put("enlace", e.getLink());
		newValues.put("descripcion", e.getDescription());
		newValues.put("fecha", e.getDate());
				
		db.insert(tabla, null, newValues);
		
		//db.execSQL("Insert into listado values("+ e.getId()+"', '"+
		//		e.getTitle()+"', '"+e.getAuthor()+"', '"+e.getLink()+"', '"+e.getDescription()+"', '"+e.getDate()+"')");
		db.close();

	}
	@Override
	public void reinicia(String tabla){
		SQLiteDatabase db = getWritableDatabase();
		db.delete(tabla,null,null);
		
	}
	
	@Override
	public ArrayList<String> listadoElemento(String tabla) {
		
	    ArrayList<String> result = new ArrayList<String>();       
	    SQLiteDatabase db = getReadableDatabase();
	    Cursor cursor = db.rawQuery("SELECT titulo FROM "+tabla, null);
	    while (cursor.moveToNext()){
	           result.add(cursor.getString(0));
	    }
	    cursor.close();
	    db.close();
	    return result;	
	}

	
	@Override
	public Elemento verElemento(String tabla, Integer i) {
		Elemento e = new Elemento();
		SQLiteDatabase db = getReadableDatabase();
		
		Cursor cursor= db.rawQuery("Select * from "+tabla+" where id="+i,null);
		
		cursor.moveToNext();
		e.setId(cursor.getInt(0));
		e.setTitle(cursor.getString(1));
		e.setAuthor(cursor.getString(2));
		e.setLink(cursor.getString(3));
		e.setDescription(cursor.getString(4));
		e.setDate(cursor.getString(5));
		
		cursor.close();
		db.close();
		
		return e;
	}

	@Override
	public long fechaActual(Integer tipo) {

		long r = 0;
		SQLiteDatabase db = getReadableDatabase();
		Cursor cursor=db.rawQuery("Select * from actualiza where id = "+tipo, null);
		if (cursor.moveToNext()) {
			r=cursor.getInt(1);
		}
		cursor.close();
		db.close();
		return r;
	}


	@Override
	public void onCreate(SQLiteDatabase db) {
		// TODO Auto-generated method stub
		db.execSQL("Create table actualiza(id integer primary key, fecha real)");
		db.execSQL("Create table eventos(id integer primary key,"+
				   "titulo text, autor text, enlace text, descripcion text, fecha text)");
		db.execSQL("Create table articulos(id integer primary key,"+
				   "titulo text, autor text, enlace text, descripcion text, fecha text)");
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub

	}


	@Override
	public void actualizar(Integer tipo) {
		
		SQLiteDatabase db = getReadableDatabase();
		Cursor cursor=db.rawQuery("Select * from actualiza where id = "+tipo, null);
		boolean r = cursor.moveToNext();
		cursor.close();
		db.close();
		
		db = getWritableDatabase();
		ContentValues newValues = new ContentValues();
		newValues.put("fecha", System.currentTimeMillis()/Sinfro.MILISEGUNDOSDIA);
		if (r) {
			db.update("actualiza",newValues,"id="+tipo, null);
			
		} else {		
			newValues.put("id", tipo);
			db.insert("actualiza", null, newValues);
		}

		
	}




}
