package com.example.sinfro;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class Sinfro extends Activity {
	final static int TEVENTO = 1;
	final static int TARTICULO = 2;
	final static int MILISEGUNDOSDIA = 86400000; 
	
	static String feedEntradas = "http://www.jerezsinfronteras.es/feed";
	static String feedEvento = "http://www.jerezsinfronteras.es/eventos/feed";
	public static Listado bd;
	private Button bEventos;
	private Button bEntradas;
	private long ahora, fecha;
	private Integer tipo;
	
	private ProgressDialog progressDialog;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sinfro);
		
		bd = new ElementoSQL(this);
		ahora = System.currentTimeMillis() / MILISEGUNDOSDIA;
		
		bEventos = (Button) findViewById(R.id.button1);
		bEventos.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//lanzarEventos(null);
				tipo=TEVENTO;
				fecha = bd.fechaActual(tipo);
				if (ahora>fecha) {	
					bd.actualizar(tipo);
					bd.reinicia("eventos");
					loadData(feedEvento);
				} else {setData();}				
			}
		});
		bEntradas = (Button) findViewById(R.id.button2);
		bEntradas.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//lanzarEventos(null);
				tipo=TARTICULO;
				fecha = bd.fechaActual(tipo);
			//	if (ahora>fecha) {	
					bd.actualizar(tipo);
					bd.reinicia("articulos");
					loadData(feedEntradas);
			//	} else {setData();}				
			}
		});
		
	}
	
	/*public void lanzarEventos(View view){
		loadData(feedEvento);	
	}*/
	
	private void setData(){
		Intent i = new Intent(this, VerEventos.class);
		i.putExtra("tipo", tipo);
		startActivity(i);	
	}
	private final Handler progressHandler = new Handler() {
	      public void handleMessage(Message msg) {
	            setData();
	            progressDialog.dismiss();
	        }
	    };
	    
	private void loadData(final String url) {
	        progressDialog = ProgressDialog.show(
	                Sinfro.this,
	                "",
	                "Por favor espere mientras se cargan los datos...",
	                true);
	        new Thread(new Runnable(){
	            @Override
	            public void run() {
	                XMLParser parser = new XMLParser(url);
	                if (tipo==TEVENTO) {
	                	parser.parse(bd, "eventos");}
	                else {
	                	parser.parse(bd, "articulos");
	                }
	                progressHandler.sendEmptyMessage(0);
	            }}).start();
	    }
	  
}
