package com.example.sinfro;

import java.io.IOException;
import java.util.List;

import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.View;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

public class VerMapa extends FragmentActivity implements LocationListener{
	
	private static final long TIEMPO_MIN = 10 * 1000 ; // 10 segundos
	private static final long DISTANCIA_MIN = 5; // 5 metros
	private LocationManager manejador;
	private LatLng situacion;
	private String proveedor;
	private GoogleMap mapa;
	private String msg, ubicacion;

	
	@Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ver_mapa);

        msg = getIntent().getStringExtra("lugar");
        ubicacion=getIntent().getStringExtra("dir")+", "+getIntent().getStringExtra("ciu");
        
        manejador = (LocationManager) getSystemService(LOCATION_SERVICE);
		Criteria criterio = new Criteria();
		criterio.setCostAllowed(false);
		criterio.setAltitudeRequired(false);
		criterio.setAccuracy(Criteria.ACCURACY_FINE);
		proveedor = manejador.getBestProvider(criterio, true);
		Location localizacion = manejador.getLastKnownLocation(proveedor);

		mapa = ((SupportMapFragment) getSupportFragmentManager()
				.findFragmentById(R.id.map)).getMap();
		mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		mapa.setMyLocationEnabled(true);
		if (localizacion!=null){
			situacion = new LatLng(localizacion.getLatitude(), localizacion.getLongitude());			
			mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(situacion, 12));
		}
		mapa.getUiSettings().setCompassEnabled(true);
		geoLocate(ubicacion);
	

	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		manejador = (LocationManager) getSystemService(LOCATION_SERVICE);
		Criteria criterio = new Criteria();
		criterio.setCostAllowed(false);
		criterio.setAltitudeRequired(false);
		criterio.setAccuracy(Criteria.ACCURACY_FINE);
		proveedor = manejador.getBestProvider(criterio, true);
		Location localizacion = manejador.getLastKnownLocation(proveedor);

		mapa = ((SupportMapFragment) getSupportFragmentManager()
				.findFragmentById(R.id.map)).getMap();
		mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		mapa.setMyLocationEnabled(true);
		if (localizacion!=null){
			situacion = new LatLng(localizacion.getLatitude(), localizacion.getLongitude());			
			mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(situacion, 12));
		}
		mapa.getUiSettings().setCompassEnabled(true);
		
	}

	public void geoLocate(String s){
		Geocoder gc= new Geocoder(this);
		try {
			  List<Address> list = gc.getFromLocationName(s,1);
			  if (!list.isEmpty()) {
			  Address address = list.get(0);			  			  		  			 
			  double lat = address.getLatitude();
			  double lng = address.getLongitude();
			  mapa.addMarker(new MarkerOptions()
				.position(new LatLng(lat,lng))
				.title("Destino")
				.snippet(msg)
				.icon(BitmapDescriptorFactory
						.fromResource(R.drawable.ic_launcher))
						.anchor(0.4f, 0.4f));
			  } else {
				  Toast.makeText(this, "Evento no localizado", Toast.LENGTH_LONG).show();
			  }
			  
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
	}
	}
	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		
	}	

	// Métodos del ciclo de vida de la actividad
	@Override protected void onResume() {
	       super.onResume();
	       manejador.requestLocationUpdates(proveedor, TIEMPO_MIN, DISTANCIA_MIN,
	                                                            this);
	}
	 
	@Override protected void onPause() {
	       super.onPause();
	       manejador.removeUpdates(this);
	}	
}
